\ *** LOCK O. 30, EXBLOCK 1E

\ INPUT: LOADSCREEN            20SEP94PZ

\ TERMINOLOGY / INTERFACE:

\ NEXTLINE
\ OPEN-INPUT    CLOSE-INPUT
\ OPEN-INCLUDE  CLOSE-INCLUDE
\ CHAR>         +CHAR
\ LINE          RES-INPTR
\ COMMENT-LINE  COMMENT-STATE
\ #EOF
\ SOURCE-NAME
\ PRINTCONTEXT

\ *** LOCK O. 31, EXBLOCK 1F

\   INPUT :  VARIABLE          14SEP94PZ

 4 CONSTANT MAX-LEVEL
 VARIABLE INCLUDE-LEVEL
 CREATE NAME[]
          /FILENAME MAX-LEVEL * ALLOT
 CREATE LINE[]    MAX-LEVEL 2* ALLOT
 CREATE FILEPOS[] MAX-LEVEL 2* ALLOT

 VARIABLE COMMENT-STATE
 VARIABLE COMMENT-LINE
 VARIABLE EOF

 DOER PREPROCESS

 VARIABLE INPTR

 : +CHAR  ( -- )  1 INPTR +! ;
 : CHAR>  ( -- C )  INPTR @ C@ ;
\ : CHAR>  ( -- C )   EOF @
\     #EOF  INPTR @ C@  ;

 : RES-INPTR  LINEBUF INPTR ! ;


\ *** LOCK O. 32, EXBLOCK 20

\   INPUT: OPEN/CLOSE-INPUT    11SEP94PZ

 : SOURCE-NAME     INCLUDE-LEVEL @
                 /FILENAME * NAME[] + ;
 : LINE  INCLUDE-LEVEL @ 2* LINE[] + ;
 : FILEPOS         INCLUDE-LEVEL @
                       2* FILEPOS[] + ;

 : CLOSE-INPUT ( -- )
     COMMENT-STATE @
         *COMMENT* ERROR
        COMMENT-LINE @ U.
        " */" LINEBUF STRCPY
         LINEBUF OFF 
     SOURCE-FILE FCLOSE ;

 : OPEN-SOURCE  ( -- )
     ASCII R ASCII S SOURCE-NAME
     SOURCE-FILE FOPEN  RES-INPTR ;

 : OPEN-INPUT ( NAME -- )
     SOURCE-NAME STRCPY
     EOF OFF  COMMENT-STATE OFF
     LINE OFF  LINEBUF OFF  FILEPOS OFF
     OPEN-SOURCE ;


\ *** LOCK O. 33, EXBLOCK 21

\   INPUT: OPEN/CLOSE-INCLUDE  11SEP94PZ

 : CLOSE-INCLUDE ( -- )
     CLOSE-INPUT
     INCLUDE-LEVEL @
         -1 INCLUDE-LEVEL +!
        ." END OF INCLUDE FILE" CR
        REOPEN-OUTFILES  OPEN-SOURCE
        SOURCE-FILE FSETIN
        FILEPOS @ FSKIP  FUNSET
         ." END OF SOURCE FILE" CR
        #EOF EOF !  ;

 : OPEN-INCLUDE  ( NAME -- )
     ." INCLUDE-FILE: "
     DUP COUNT TYPE CR
     INCLUDE-LEVEL @ 1+ DUP MAX-LEVEL U<
         INCLUDE-LEVEL !
        SOURCE-FILE FCLOSE
        REOPEN-OUTFILES  OPEN-INPUT
         *INC-NEST* ERROR  2DROP
         ;


\ *** LOCK O. 34, EXBLOCK 22

\   INPUT :  NEXTLINE           14SEP94PZ

 VARIABLE LISTING  LISTING OFF

 : PRINTSOURCELINE  ( -- )
     LINEBUF /LINEBUF BOUNDS
       C@ ?DUP 0=   
     EMIT  CR ;

 : NEXTLINE ( -- )
     SOURCE-FILE FEOF?
         CLOSE-INCLUDE
        EOF @ ?EXIT 
     1 LINE +!
     SOURCE-FILE FSETIN
     LINEBUF /LINEBUF 1- #CR FGET2DELIM
        *LONGLINE* ?ERROR
     DUP FILEPOS +!
     1- /LINEBUF 1- UMIN
     LINEBUF + 0 SWAP C!
     FUNSET
     LISTING @  LINE @ U.
            ." : " PRINTSOURCELINE 
     RES-INPTR  PREPROCESS ;


\ *** LOCK O. 35, EXBLOCK 23

\   INPUT :  PRINTCONTEXT      11SEP94PZ

MAKE PRINTCONTEXT  ( -- )
      CONTEXT? @ 0= ?EXIT
      LINEBUF C@ 0= ?EXIT
      PRINTSOURCELINE
      INPTR @ LINEBUF - 1- 0 MAX
      SPACES  ^ EMIT  CR ;

 : INIT-INPUT ( -- )
     INCLUDE-LEVEL OFF
     LINEBUF OFF  RES-INPTR
     CONTEXT? ON ;
    INIT: INIT-INPUT

\ CONTEXT? IS DEFINED IN ERRORHANDLER
\ AND SHALL AVOID CONTEXT PRINTING
\ IF AN ERROR OCCURS DURING INIT WHILE
\ NO VALID LINEBUF CONTENT EXISTS.
