\ *** LOCK O. 48, EXBLOCK 30

\ PARSER LOADSCREEN            21SEP94PZ

 VARIABLE PROTOS2PATCH

ON

: TESTSTACK  ( -- )
     HERE $80 + SP@ U> *STACK* ?FATAL
     UP@ UDP @ + $40 + RP@ U>
                      *RSTACK* ?FATAL ;


\ *** LOCK O. 49, EXBLOCK 31

\ PARSER: TOOLS                22FEB91PZ

: COMES? ( TOKENVALUE TOKEN -- FLAG )
    THISWORD DNEGATE D+ OR
     FALSE  ACCEPT TRUE  ;

: COMES-A? ( TOKEN -- TOKENVALUE TRUE )
           ( TOKEN -- FALSE )
    THISWORD ROT = DUP NOT
     NIP  ;

: EXPECT ( TOKENVALUE TOKEN -- )
    2DUP COMES?
        2DROP
        WORD. *EXPECTED* ERROR
        ;

: EXPECT';'  ASCII ; #CHAR# EXPECT ;
: EXPECT':'  ASCII : #CHAR# EXPECT ;
: EXPECT'('  ASCII ( #CHAR# EXPECT ;
: EXPECT')'  ASCII ) #CHAR# EXPECT ;
: EXPECT']'  ASCII ] #CHAR# EXPECT ;


\ : SKIPWORD ( -- )
\    *IGNORED* ERROR NEXTWORD WORD. ;


\ *** LOCK O. 50, EXBLOCK 32

  CR .( SUBMODULE EXPRESSION ) CR

\ PARSER: ATOM                 13SEP94PZ

: CP$[ ( -- JMP ADR )
     .JMP-AHEAD  .LABEL ;

: CP]$ ( JMP ADR -- ADR )
     SWAP .RESOLVE-JMP ;

DO$: COMPILE$  ( -- ADR )
        CP$[ .BYTE CP]$ ;

\ OBJ IN STACK COMMENTS REPRESENTS A DATA VALUE IN AN EXPRESSION AND
\ CONSISTS OF TWO VALUES: OBJ = VAL TYPE
\ VAL WILL BE THE ACTUAL VALUE IN CASE THE EXPRESSION SO FAR IS ALREADY
\ KNOWN AT COMPILE TIME, OR A PLACEHOLDER IN CASE THE VALUE IS ONLY
\ KNOWN AT RUN TIME.
\ TYPE REPRESENTS THE DATA TYPE OF THE VALUE, A BITMAP MADE UP OF THE
\ DEFINITIONS %INT, %POINTER, %FUNCTION ETC. FROM THE BEGINNING OF
\ CODEGEN.FTH.

: ATOM ( -- OBJ )
   #NUMBER# COMES-A?
       ACCEPT DO-NUMATOM  EXIT 
   #ID#     COMES-A?
       ACCEPT DO-IDATOM   EXIT 
   #STRING# COMES-A?
       DROP COMPILE$
      DO-STRINGATOM  ACCEPT EXIT 
   ." A VALUE" *EXPECTED* ERROR
   \ CONSIDER SKIPWORD
   0 DO-NUMATOM ;


\ *** LOCK O. 51, EXBLOCK 33

\ PARSER: PRIMARY              15MAR91PZ

DOER EXPRESSION
DOER ASSIGN

: PRIMARY[] ( OBJ1 -- OBJ2 )
   VALUE
   EXPRESSION VALUE  DO-ADD
   DO-POINTER
   EXPECT']' ;


\ *** LOCK O. 52, EXBLOCK 34

\   PARSER: PRIMARY            26APR20PZ


: ARGUMENTS  ( -- )
      ASSIGN PUT-ARGUMENT
     ASCII , #CHAR# COMES? NOT  ;

: PRIMARY() ( OBJ1 -- OBJ2 )
     FUNCTION? NOT *NOFUNC* ?ERROR
     %FASTCALL IS?
         PREPARE-FAST-CALL
        ASCII ) #CHAR# COMES? NOT
            ASSIGN PUT-FAST-ARGUMENT
           EXPECT')' 
        DO-FAST-CALL
         PREPARE-CALL
        ASCII ) #CHAR# COMES? NOT
            ARGUMENTS
           EXPECT')' 
        DO-CALL 
      %CONSTANT %FUNCTION + %FASTCALL + CLR ;


\ *** LOCK O. 53, EXBLOCK 35

\   PARSER: PRIMARY            11SEP94PZ

: PRIMARY ( -- OBJ )
     TESTSTACK
     ASCII ( #CHAR# COMES?
         EXPRESSION
        EXPECT')'
         ATOM 
      MARK >R
     ASCII ( #CHAR# COMES?
         PRIMARY() 
     ASCII [ #CHAR# COMES?
         PRIMARY[] 
     R> ADVANCED? NOT  ;


\ *** LOCK O. 54, EXBLOCK 36

\ PARSER: UNARY                22FEB91PZ

: COMES-TAB-TOKEN? ( TAB TOKEN -- CFA TRUE )
                   ( TAB TOKEN -- FALSE )
     COMES-A?
         SWAP  DUP 2+ SWAP @ BOUNDS
         DUP  @ =
           ACCEPT  DROP   2+ @
          TRUE  EXIT 
        4 +
        
     DROP  FALSE ;

CREATE UNARY-TAB1  7  4 * ,
  <->   ,  ' DO-NEG     ,
  <!>   ,  ' DO-NOT     ,
  <INV> ,  ' DO-INV     ,
  <*>   ,  ' DO-POINTER ,
  <AND> ,  ' DO-ADRESS  ,
  <++>  ,  ' DO-PREINC  ,
  <-->  ,  ' DO-PREDEC  ,

CREATE UNARY-TAB2  2  4 * ,
  <++>  ,  ' DO-POSTINC ,
  <-->  ,  ' DO-POSTDEC ,

: UNARY ( -- OBJ )  RECURSIVE
   UNARY-TAB1 #OPER# COMES-TAB-TOKEN?
      >R UNARY R> EXECUTE  EXIT 
   PRIMARY
   UNARY-TAB2 #OPER# COMES-TAB-TOKEN?
      EXECUTE  EXIT  ;


\ *** LOCK O. 55, EXBLOCK 37

\ PARSER: BINARY               06MAR91PZ

: BINARY  ( TAB -- )
    CREATE , DUP 4 * ,  0
      SWAP , , 
    DOES>   ( TAB -- OBJ )
     DUP @ EXECUTE
      2 PICK 2+ #OPER# COMES-TAB-TOKEN?  >R
     VALUE  2 PICK @ EXECUTE VALUE
     R> EXECUTE 
     2 ROLL DROP ;


\ *** LOCK O. 56, EXBLOCK 38

\   PARSER: BINARY             08APR90PZ

  <*>   ' DO-MULT
  </>   ' DO-DIV
  <%>   ' DO-MOD
  3  ' UNARY   BINARY PRODUCT

  <+>   ' DO-ADD
  <->   ' DO-SUB
  2  ' PRODUCT BINARY SUM

  <<<>  ' DO-SHL
  <>>>  ' DO-SHR
  2  ' SUM     BINARY SHIFT

  <<>   ' DO-LT
  <<=>  ' DO-LE
  <>>   ' DO-GT
  <>=>  ' DO-GE
  4  ' SHIFT   BINARY COMP

  <==>  ' DO-EQ
  <!=>  ' DO-NE
  2  ' COMP    BINARY EQUAL


\ *** LOCK O. 57, EXBLOCK 39

\   PARSER: BINARY             09OCT90PZ

  <AND> ' DO-AND
  1  ' EQUAL   BINARY BIT-AND

  <XOR> ' DO-XOR
  1  ' BIT-AND BINARY BIT-XOR

  <OR>  ' DO-OR
  1  ' BIT-XOR BINARY BIT-OR

: L-AND ( -- OBJ )
     BIT-OR
       <L-AND> #OPER# COMES? 
     DO-L-AND.1  BIT-OR
     DO-L-AND/OR.2   ;

: L-OR ( -- OBJ )
     L-AND
       <L-OR> #OPER# COMES? 
     DO-L-OR.1  L-AND
     DO-L-AND/OR.2   ;


\ *** LOCK O. 58, EXBLOCK 3A

\   PARSER: BINARY             07APR90PZ

: CONDITIONAL ( -- OBJ )
     L-OR
     ASCII ? #CHAR# COMES?
         DO-COND1
        RECURSIVE CONDITIONAL
        DO-COND2
        EXPECT':'
        RECURSIVE CONDITIONAL
        DO-COND3  ;


\ *** LOCK O. 59, EXBLOCK 3B

\ PARSER: ASSIGN               06MAR91PZ

CREATE ASSIGN-OPER  11  4 * ,
  <=>    ,    0       ,
  <*=>   ,  ' DO-MULT ,
  </=>   ,  ' DO-DIV  ,
  <%=>   ,  ' DO-MOD  ,
  <+=>   ,  ' DO-ADD  ,
  <-=>   ,  ' DO-SUB  ,
  <<<=>  ,  ' DO-SHL  ,
  <>>=>  ,  ' DO-SHR  ,
  <AND=> ,  ' DO-AND  ,
  <XOR=> ,  ' DO-XOR  ,
  <OR=>  ,  ' DO-OR   ,


\ *** LOCK O. 60, EXBLOCK 3C

\   PARSER: ASSIGN             08APR90PZ

  MAKE ASSIGN ( -- OBJ )
     CONDITIONAL
     ASSIGN-OPER #OPER# COMES-TAB-TOKEN?
         ?DUP
            >R  PREPARE-ASGNOP
           RECURSIVE ASSIGN VALUE
           R> EXECUTE
            PREPARE-ASSIGN
           RECURSIVE ASSIGN VALUE 
        DO-ASSIGN  ;


\ *** LOCK O. 61, EXBLOCK 3D

\ PARSER: EXPRESSION           29OCT90PZ

  MAKE EXPRESSION  ( -- OBJ )
   ASSIGN
   ASCII , #CHAR# COMES?
       VALUE NON-CONSTANT
       2DROP RELEASE-ACCU
      ASSIGN VALUE NON-CONSTANT
      ASCII , #CHAR# COMES? 0= 
       ;


: CONSTANT-EXPRESSION ( -- VAL )
     ASSIGN VALUE  %CONSTANT ISN'T?
     *NOCONST* ?ERROR  DROP ;

: EXPR-TO-ACCU  ( -- )
     EXPRESSION VALUE NON-CONSTANT
     2DROP RELEASE-ACCU ;


\ *** LOCK O. 62, EXBLOCK 3E

\ PARSER: STATEMENT            12MAR91PZ

  .( SUBMODULE STATEMENT ) CR

DOER COMPOUND
DOER STATEMENT

: EXPRESSION-STMT ( -- )
      EXPR-TO-ACCU  EXPECT';' ;

: RETURN-STMT ( -- )
      ASCII ; #CHAR# COMES? NOT
          EXPRESSION-STMT 
      .RTS ;


\ *** LOCK O. 63, EXBLOCK 3F

\   PARSER: STATEMENT          22FEB91PZ

: (EXPR-TO-ACCU)  ( -- )
     EXPECT'('  EXPR-TO-ACCU  EXPECT')' ;

: IF-STMT  ( -- )
     (EXPR-TO-ACCU)
     .JMZ-AHEAD
     STATEMENT
     <ELSE> #KEYWORD# COMES?
         .JMP-AHEAD SWAP .RESOLVE-JMP
        STATEMENT 
     .RESOLVE-JMP ;


\ *** LOCK O. 64, EXBLOCK 40

\   PARSER: STATEMENT          12MAR91PZ

: ?DROP&EXIT ( N FLAG -- N / -- )
       DROP RDROP  ;

: NEW  ( LIST -- )
     HEAP> ?DUP 0= ?DROP&EXIT
     DUP 2+ OFF  SWAP HOOK-INTO ;

: RESOLVE  ( LIST -- )
      DUP HOOK-OUT  DUP >HEAP
     2+ @ ?DUP 
     .RESOLVE-JMP  DROP ;


\ *** LOCK O. 65, EXBLOCK 41

\   PARSER: STATEMENT          12MAR91PZ

VARIABLE BREAKS
VARIABLE CONTS

: ANOTHER  ( LIST -- )
     DUP @ 0=  *ILL-BRK* ERROR
              DROP EXIT 
     HEAP> ?DUP 0= ?DROP&EXIT
     .JMP-AHEAD OVER 2+ !
     SWAP HOOK-INTO ;

: BREAK-STMT ( -- )
     BREAKS ANOTHER  EXPECT';' ;

: CONTINUE-STMT ( -- )
     CONTS ANOTHER  EXPECT';' ;

: INIT-BREAKS  BREAKS OFF CONTS OFF ;
     INIT: INIT-BREAKS


\ *** LOCK O. 66, EXBLOCK 42

\   PARSER: STATEMENT          18APR94PZ

VARIABLE SWITCH-STATE ( 0/-1/DEF.ADR)
VARIABLE CASES

: INIT-SWITCH   SWITCH-STATE OFF
     CASES OFF ;
    INIT: INIT-SWITCH

: CASE-STMT ( -- )
     CONSTANT-EXPRESSION
     EXPECT':'
     SWITCH-STATE @ 0=    DROP
        *NOSWITCH* ERROR EXIT 
     HEAP> ?DUP 0= ?DROP&EXIT
     DUP  CASES HOOK-INTO
     2+ .LABEL OVER !  2+ ! ;

: DEFAULT-STMT ( -- )
     EXPECT':'
     SWITCH-STATE @ 1+
         *ILL-DEFAULT* ERROR
         .LABEL SWITCH-STATE !
         ;


\ *** LOCK O. 67, EXBLOCK 43

\   PARSER: STATEMENT          27MAY91PZ

: CASES-RESOLVE ( -- )
      CASES HOOK-OUT  DUP >HEAP
     2+ DUP @ ?DUP 
     .WORD 2+ @ .WORD 
     DROP  0 .WORD ;

: SWITCH-STMT  ( -- )
     SWITCH-STATE @ SWITCH-STATE ON
     BREAKS NEW  CASES NEW
     (EXPR-TO-ACCU)  .JMP-AHEAD
     STATEMENT
     .JMP-AHEAD  SWAP  .RESOLVE-JMP
     .SWITCH  CASES-RESOLVE
     SWITCH-STATE @ NOT ?DUP
         NOT .JMP   \ DEFAULT
     .RESOLVE-JMP  BREAKS RESOLVE
     SWITCH-STATE ! ;

\ $SWITCH TAY:PLA:INA:STA ZP:TYA:LDY#0
\  [[ PHA:LDA(ZP):NE?[[ STA VEC:WINC ZP
\   PLA:CMP(ZP):EQ?[ JMP(VEC) ]?
\   WINC ZP ]]? WINC ZP:JMP(ZP)


\ *** LOCK O. 68, EXBLOCK 44

\   PARSER: STATEMENT          22FEB91PZ

: DO-STMT  ( -- )
     BREAKS NEW  CONTS NEW
     .LABEL  STATEMENT  CONTS RESOLVE
     <WHILE> #KEYWORD# EXPECT
     (EXPR-TO-ACCU)  .JMN
     BREAKS RESOLVE  EXPECT';' ;

: WHILE-STMT  ( -- )
     BREAKS NEW  CONTS NEW
     .LABEL  (EXPR-TO-ACCU)
     .JMZ-AHEAD
     STATEMENT  CONTS RESOLVE
     SWAP .JMP  .RESOLVE-JMP
     BREAKS RESOLVE ;


\ *** LOCK O. 69, EXBLOCK 45

\   PARSER: STATEMENT          22FEB91PZ

\ : 1ST-EXPRESSION  ( -- )
\    ASCII ; #CHAR# COMES? NOT
\       EXPR-TO-ACCU  EXPECT';'  ;

: 2ND-EXPRESSION? ( -- FLAG )
     ASCII ; #CHAR# COMES? NOT DUP
        EXPR-TO-ACCU  EXPECT';'  ;

: 1ST-EXPRESSION  ( -- )
     2ND-EXPRESSION? DROP ;

: 3RD-EXPRESSION  ( -- )
     ASCII ) #CHAR# COMES? NOT
         EXPR-TO-ACCU
        EXPECT')'  ;


\ *** LOCK O. 70, EXBLOCK 46

\   PARSER: STATEMENT          22FEB91PZ

: FOR-STMT ( -- )
     BREAKS NEW  CONTS NEW
     EXPECT'('
     1ST-EXPRESSION
     .LABEL                     \ 
     2ND-EXPRESSION? DUP >R     \ ^
         .JMN-AHEAD ( TRUE )  \ ^
           .JMP-AHEAD ( FALSE ) \ ^
         .JMP-AHEAD 0   \ ^
     .LABEL                     \ ^
     3RD-EXPRESSION             \ ^^
     3 ROLL .JMP                \ ^
     ROT .RESOLVE-JMP           \  ^
     STATEMENT                  \   ^
     CONTS RESOLVE              \   ^
     .JMP                       \   
     R>  .RESOLVE-JMP         \   
         DROP 
     BREAKS RESOLVE ;


\ *** LOCK O. 71, EXBLOCK 47

\   PARSER: STATEMENT          12MAR91PZ

CREATE STATEMENT-TAB  10  4 * ,
  <BREAK>   ,  ' BREAK-STMT    ,
  <CONT>    ,  ' CONTINUE-STMT ,
  <IF>      ,  ' IF-STMT       ,
  <DO>      ,  ' DO-STMT       ,
  <WHILE>   ,  ' WHILE-STMT    ,
  <FOR>     ,  ' FOR-STMT      ,
  <CASE>    ,  ' CASE-STMT     ,
  <DEFAULT> ,  ' DEFAULT-STMT  ,
  <SWITCH>  ,  ' SWITCH-STMT   ,
  <RETURN>  ,  ' RETURN-STMT   ,

: STATEMENT? ( -- FLAG )  TRUE
  STATEMENT-TAB #KEYWORD# COMES-TAB-TOKEN?
     EXECUTE  EXIT 
  #CHAR# COMES-A? 
  ASCII  CASE?  ACCEPT COMPOUND   EXIT 
  ASCII ; CASE?  ACCEPT            EXIT 
  ASCII  CASE?  NOT               EXIT 
  DROP   DROP
  MARK EXPRESSION-STMT ADVANCED? ;


 MAKE STATEMENT ( -- )
  TESTSTACK
  STATEMENT? NOT
      ." STATEMENT" *EXPECTED* ERROR  ;


\ *** LOCK O. 73, EXBLOCK 49

\ PARSER: DECLARATION BASICS   14MAR91PZ

  .( SUBMODULE DEFINITION ) CR

VARIABLE #/OBJ
VARIABLE []DIM'D
VARIABLE #INITS
VARIABLE []INIT'D

VARIABLE EXTERN

: >TYPE  ( DESC -- DESC.TYPE )
          ; IMMEDIATE

\ HAENGT VON DER WIRKUNGSWEISE VON
\ 2@ U. 2! AB, MIT DENEN NORMALERWEISE
\ AUF DIE SYMBOLTABELLE ZUGEGRIFFEN
\ WIRD.


\ *** LOCK O. 74, EXBLOCK 4A

\   PARSER: DECLARATION BASICS 14MAR91PZ

VARIABLE FUNCTION :DOES> 0 ;

: DEFINED   SWAP ! ;
: DEFINED?  SWAP @ = ;

\   FUNCTION [ NOT ] DEFINED
\   FUNCTION [ NOT ] DEFINED?


\ *** LOCK O. 75, EXBLOCK 4B

\   PARSER: TYPE-SPECIFIERS    14MAR91PZ

: TYPE-NAME? ( TYPE -- TYPE' FLAG )
     <FASTCALL> #KEYWORD# COMES?
         %FASTCALL SET 
     <CHAR> #KEYWORD# COMES?
         SET-CHAR TRUE
         <INT> #KEYWORD# COMES?
            SET-INT TRUE
            FALSE   ;

: REGISTER? ( TYPE -- TYPE' FLAG )
     <REGISTER> #KEYWORD# COMES?
         ( %REGISTER SET ) TRUE
         FALSE  ;

: EXTERN? ( TYPE -- TYPE' FLAG )
     <EXTERN> #KEYWORD# COMES?
         %EXTERN SET  %OFFSET CLR
           EXTERN ON  TRUE
         FALSE  ;


\ *** LOCK O. 76, EXBLOCK 4C

\   PARSER: TYPE-SPECIFIERS    14MAR91PZ

: RANGE? ( TYPE -- TYPE' FLAG )
     EXTERN? ?DUP ?EXIT
     <STATIC> #KEYWORD# COMES?
         %EXTERN CLR TRUE
         FALSE  ;

: CLASS? ( TYPE -- TYPE' FLAG )
     REGISTER? ?DUP ?EXIT
     EXTERN?   ?DUP ?EXIT
     <AUTO> #KEYWORD# COMES?
         TRUE EXIT 
     <STATIC> #KEYWORD# COMES?
         %OFFSET CLR TRUE
         FALSE  ;


\ *** LOCK O. 77, EXBLOCK 4D

\   PARSER: TYPE-SPECIFIERS    11SEP94PZ

DEFER 'CLASS?

: OR-TYPE: ( CFA -- )  CREATE ,
    DOES> ( TYPE PFA -- TYPE' FLAG )
     @  'CLASS?   EXTERN OFF
     'CLASS?
         TYPE-NAME? DROP  TRUE
         TYPE-NAME?
            'CLASS? DROP  TRUE
            FALSE   ;

' CLASS? OR-TYPE: CLASS-OR-TYPE?
' RANGE? OR-TYPE: RANGE-OR-TYPE?
' REGISTER? OR-TYPE: REGISTER-OR-TYPE?


\ *** LOCK O. 78, EXBLOCK 4E

\   PARSER: DECLARATOR         08MAR91PZ

CREATE ID-BUF /ID 1+ ALLOT

: EXPECT-ID,OK?  ( -- TOKENVALUE TRUE / -- FALSE)
     #ID# COMES-A? DUP  ACCEPT
        ." IDENTIFIER" *EXPECTED* ERROR  ;

: ID-TO-BUF  ( -- ID-BUF )
     EXPECT-ID,OK?  ID-BUF OVER C@ 1+ CMOVE  ID-BUF ;

: ID-TO-LOCAL  ( -- LOCAL-ENTRY )
     EXPECT-ID,OK?
      PUTLOCAL  ID-BUF ( AS DUMMY LOCAL-ENTRY )  ;

VARIABLE HANDLE-ID-XT  ' ID-TO-BUF HANDLE-ID-XT !

DOER (DECLARATOR ( TYPE -- ID-HANDLE TYPE' )

: PARAM-OK? ( ID-HANDLE TYPE -- ID-HANDLE TYPE TRUE )
            ( ID-HANDLE TYPE -- FALSE )
    ARRAY? []DIM'D @ 0= AND  %L-VALUE SET 
    FUNCTION? DUP >R  UNNESTLOCAL 
    ARRAY? R> OR  *PARAM* ERROR 2DROP FALSE  TRUE  ;

: PARAMETER' ( ID-BUF TYPE -- )
    PARAM-OK? 
      SWAP FINDPARAM ?DUP 0=
         *UNDEF* ERROR DROP  >TYPE ! 
     ;

: TYPED-PARAMETERS) ( -- )
     HANDLE-ID-XT PUSH  ['] ID-TO-LOCAL HANDLE-ID-XT !
      %LOCAL REGISTER-OR-TYPE? NOT  2DROP EXIT 
     (DECLARATOR  PARAM-OK?  2 DYN-ALLOT SWAP ROT 2! 
     ASCII , #CHAR# COMES? NOT  ;

: ID-PARAMETERS) ( -- )
      EXPECT-ID,OK?  PUTLOCAL  2 DYN-ALLOT %LOCAL  ROT 2! 
     ASCII , #CHAR# COMES? NOT  ;

: [PARAMETERS]) ( -- )
     DYN-RESET
     ASCII ) #CHAR# COMES? ?EXIT
     #ID# COMES-A?  DROP ID-PARAMETERS) L TYPED-PARAMETERS) 
     EXPECT')' ;


\ *** LOCK O. 79, EXBLOCK 4F

\   PARSER: DECLARATOR         14MAR91PZ

: HANDLE-FUNCTION ( TYPE -- TYPE' )
     FUNCTION?
         UNNESTLOCAL 
     %FUNCTION IS?
        *DOUBLE-FUNC* ?ERROR
     %FUNCTION SET
     %POINTER IS?
         []DIM'D @ *???* ?ERROR
        []DIM'D OFF  1 #/OBJ !
        %POINTER CLR  %L-VALUE SET
         %L-VALUE CLR 
     FUNCTION?
         NESTLOCAL [PARAMETERS])
         EXPECT')'
         ;


\ *** LOCK O. 80, EXBLOCK 50

\   PARSER: DECLARATOR         08MAR91PZ

: SET-POINTER ( TYPE -- TYPE' )
     %POINTER IS?  *DOUBLE-PTR* ?ERROR
     %POINTER SET ;

: HANDLE-ARRAY ( TYPE -- TYPE' )
     ASCII ] #CHAR# COMES? NOT
         %FUNCTION IS? >R
        CONSTANT-EXPRESSION R>
            DROP *???* ERROR
            #/OBJ ! []DIM'D ON 
        EXPECT']' 
     SET-POINTER  %FUNCTION ISN'T?
         %L-VALUE CLR  ;

\ FRUEHER:
\     SET-POINTER  %FUNCTION IS?
\         ASCII ] #CHAR# EXPECT
\         %L-VALUE CLR
\        ASCII ] #CHAR# COMES? NOT
\            CONSTANT-EXPRESSION
\           #/OBJ !  []DIM'D ON
\           ASCII ] #CHAR# EXPECT 
\         ;


\ *** LOCK O. 81, EXBLOCK 51

\   PARSER: DECLARATOR         06MAR91PZ

MAKE (DECLARATOR ( TYPE -- ID-HANDLE TYPE' )
     1 #/OBJ !  []DIM'D OFF
    FALSE  <*> #OPER# COMES? 
     *DOUBLE-PTR* ?ERROR TRUE  >R
     ASCII ( #CHAR# COMES?  \ )
         RECURSIVE (DECLARATOR
           EXPECT')'
         HANDLE-ID-XT PERFORM SWAP 
      MARK >R
     ASCII [ #CHAR# COMES?
         HANDLE-ARRAY 
     ASCII ( #CHAR# COMES?  \ )
         HANDLE-FUNCTION 
     R> ADVANCED? NOT 
     R>  SET-POINTER  ;

DEFER 'DECLARATOR ( TYPE' -- )

: DECLARATOR ( TYPE -- )
     ID-BUF OFF  (DECLARATOR
     %FUNCTION ISN'T?  %FASTCALL IS? *FASTCALL* ?ERROR 
     'DECLARATOR ;


\ *** LOCK O. 82, EXBLOCK 52

\   PARSER: DECLARATOR         12MAR91PZ

VARIABLE (1ST
: 1ST  (1ST ON ;
: 2ND  (1ST OFF ;
: 1ST? (1ST @ ;


: DECLARATOR-LIST';' ( TYPE -- )
     >R
     FUNCTION NOT DEFINED
     R@ 1ST DECLARATOR
     FUNCTION DEFINED?
         RDROP EXIT 
      ASCII , #CHAR# COMES? 
     R@ 2ND DECLARATOR 
     RDROP EXPECT';' ;


\ *** LOCK O. 83, EXBLOCK 53

\   PARSER: STATIC INITIALIZATION

\ ECAUSE WE ALLOCATE STATIC VARIABLES FROM THE TOP OF THE AVAILABLE
\ MEMORY DOWNWARDS, AND WE ISSUE STATIC INIT VALUES DOWNWARD, TOO,
\ ACCORDINGLY, WE NEED TO ISSUE ARRAY INIT VALUES STARTING AT THE END
\ OF THE ARRAY, THUS WE NEED TO REVERSE THEIR ORDER. HAT'S WHY WE
\ LEAVE THE INIT VALUES ON THE STACK INSTEAD OF ISSUING THEM DIRECTLY.

: 1MORE ( N -- N )
     TESTSTACK  1 #INITS +! ;

DO$: INIT$ ( -- VALUES )
        NOOP 1MORE NOOP ;

: INIT[] ( -- VALUES )
      CONSTANT-EXPRESSION 1MORE
     ASCII  #CHAR# COMES? NOT 
     ASCII , #CHAR# EXPECT
     ASCII  #CHAR# COMES?
         0  1MORE  TRUE
         FALSE 
      ;

: STATIC-INIT ( TYPE -- VALUES )
     IS-CHAR? SWAP ARRAY? NIP  ( IS-CHAR? ARRAY? )
     #STRING# COMES-A?
         DROP
        AND 0= *!=TYPE* ?ERROR
        []INIT'D ON  INIT$ ACCEPT EXIT 
     ASCII  #CHAR# COMES?  \ 
         NIP 0= *!=TYPE* ?ERROR
        []INIT'D ON  INIT[] EXIT 
     2DROP
     CONSTANT-EXPRESSION 1MORE ;


\ *** LOCK O. 85, EXBLOCK 55

\   PARSER: DECLARE-FCNT/DATA  14MAR91PZ

: CHECK-TYPES-EQUAL ( TYPE1 TYPE2 -- )
     XOR %DECL.MASK AND
     *!=TYPE* ?ERROR ;

: DECLARE ( ID-BUF TYPE -- )
     SWAP FINDGLOBAL ?DUP
         >TYPE @ CHECK-TYPES-EQUAL
         DROP *UNDEF* ERROR  ;

: DEFINE-EXTERN ( ID-BUF TYPE -- )
    FUNCTION?  UNNESTLOCAL 
    SWAP PUTGLOBAL
    CONSTANT-EXPRESSION -ROT 2! ;


\ *** LOCK O. 86, EXBLOCK 56

\   PARSER: DEFINE-DATA        14MAR91PZ

: DIM-ARRAY ( TYPE -- TYPE' )
     []DIM'D @ 0=
         []INIT'D @
            #INITS @ #/OBJ !
            %L-VALUE SET 
         ;

: SIZE/# ( TYPE -- TYPE N )
     %POINTER %FUNCTION + ISN'T? >R
     ARRAY? >R IS-CHAR? R> R> OR AND
     2+ ;


\ *** LOCK O. 87, EXBLOCK 57

\   PARSER: DEFINE-DATA        11SEP94PZ

DEFER 'STAT,

: CREATE-STATIC
    ( [VALUES] TYPE -- OBJ )
     SIZE/# 1-
         ['] STAT,  ['] CSTAT,
          'STAT,
     >R #INITS @  #/OBJ @
     U>  *INITER* ERROR
        #INITS @  #/OBJ @  DUP #INITS !
          DROP   
     #/OBJ @ #INITS @
        ? 0 'STAT, 
     #INITS @ 0
        ?   'STAT, 
     STATICADR> R> ;


\ *** LOCK O. 88, EXBLOCK 58

\   PARSER: DEFINE-DATA        11SEP94PZ

: CREATE-DYN ( TYPE -- OBJ )
     SIZE/# #/OBJ @ *  DYN-ALLOT SWAP ;


\ *** LOCK O. 89, EXBLOCK 59

\   PARSER: DEFINE-DATA        11SEP94PZ

DEFER 'PUTSYMBOL

: DEFINE-DATA ( ID-BUF TYPE -- )
    EXTERN @
        DECLARE EXIT 
    #INITS OFF  []INIT'D OFF
    %OFFSET IS?
       ARRAY?  DIM-ARRAY 
      CREATE-DYN
      <=> #OPER# COMES?
         EXPR-TO-ACCU  SIZE/# .SIZE  OVER .STA.S(BASE),# 
       <=> #OPER# COMES?  DUP >R STATIC-INIT R> 
      ARRAY?  DIM-ARRAY 
      CREATE-STATIC 
    ROT 'PUTSYMBOL 2! ;


\ *** LOCK O. 90, EXBLOCK 5A

\   PARSER: DEFINE FUNCTION    25APR94PZ

VARIABLE PROTOS2RESOLVE

: PROTOTYPE ( ID-BUF TYPE -- )
     UNNESTLOCAL
     OVER FINDGLOBAL ?DUP
         >TYPE @ CHECK-TYPES-EQUAL DROP
         %PROTO SET  .LABEL SWAP
        ROT PUTGLOBAL  DUP >R  2!
        HEAP> ?DUP
            DUP 2+  R> OVER !
                  2+  .JMP-AHEAD 1+ SWAP !
           PROTOS2RESOLVE HOOK-INTO
            RDROP 
         ;

: INIT-PATCHES
     PROTOS2RESOLVE OFF
     PROTOS2PATCH   OFF ;

     INIT: INIT-PATCHES


\ *** LOCK O. 91, EXBLOCK 5B

\   PARSER: DEFINE FUNCTION    25APR94PZ

: SORT-IN  ( ADDR2PATCH -- LIST )
     >R  PROTOS2PATCH 
        DUP @ 0=  RDROP EXIT 
        DUP @ 4 + @ R@ U<
                  RDROP EXIT 
        @  ;

: ADJUST-PROTOTYPE
    ( OBJ DESC TYPE -- OBJ DESC )
     2 PICK CHECK-TYPES-EQUAL   >R
     ( OBJ )
     PROTOS2RESOLVE  DUP @
        ( OBJ LIST/PREV ELEMENT )
        DUP 0= *COMPILER* ?FATAL
        2+ @ R@ -   @ 
     ( OBJ LIST/PREV ) HOOK-OUT
     ( OBJ ELEMENT)  2 PICK OVER 2+ !
     DUP 4 + @  SORT-IN  HOOK-INTO R> ;

: FIND/PUTGLOBAL ( OBJ ID-BUF -- OBJ DESC )
     DUP FINDGLOBAL ?DUP
         DUP >TYPE @ %PROTO IS?
            ROT DROP ADJUST-PROTOTYPE EXIT
            2DROP  
     PUTGLOBAL ;


\ *** LOCK O. 92, EXBLOCK 5C

\   PARSER: DEFINE-FUNCTION    14MAR91PZ

: DECLARE-PARAMETERS ( -- )
     ['] PARAMETER'  'DECLARATOR
      %LOCAL
     REGISTER-OR-TYPE? 
     DECLARATOR-LIST';'  DROP ;


\ *** LOCK O. 93, EXBLOCK 5D

\   PARSER: DEFINE FUNCTION    14MAR91PZ

: DEFINE-FUNCTION ( ID-BUF TYPE -- )
     #CHAR# COMES-A?
         DUP ASCII ; = SWAP ASCII , = OR
            PROTOTYPE EXIT  
     1ST?
         %FASTCALL IS? *FASTCALL* ?ERROR
        .LABEL SWAP ROT FIND/PUTGLOBAL 2!
         DECLARE-PARAMETERS
          ASCII  #CHAR# EXPECT  \ 
          COMPOUND
         UNNESTLOCAL
        .RTS  FLUSHCODE
        FUNCTION DEFINED
         2DROP *SYNTAX* ERROR  ;


\ *** LOCK O. 94, EXBLOCK 5E

\   PARSER: TYPE-SPECIFIERS    11SEP94PZ

: GLOBAL  ( -- )
     ['] PUTGLOBAL  'PUTSYMBOL ;

: LOCAL  ( -- )
     ['] PUTLOCAL  'PUTSYMBOL ;


: DECLARATION' ( ID-BUF TYPE -- )
     FUNCTION?
         UNNESTLOCAL %OFFSET CLR %EXTERN SET DECLARE
         LOCAL DEFINE-DATA  ;

: DEFINITION' ( ID-BUF TYPE -- )
     <*=> #OPER# COMES?
         DEFINE-EXTERN EXIT 
     FUNCTION?
         DEFINE-FUNCTION
         GLOBAL DEFINE-DATA  ;


\ *** LOCK O. 95, EXBLOCK 5F

\   PARSER: DECLARATION        14MAR91PZ

: DECLARATION? ( -- FLAG )
     ['] DECLARATION'  'DECLARATOR
     %LOCAL CLASS-OR-TYPE?
         DECLARATOR-LIST';' TRUE
         DROP FALSE  ;

: DEFINITION? ( -- FLAG )
     ['] DEFINITION'  'DECLARATOR
     %GLOBAL RANGE-OR-TYPE?
         DECLARATOR-LIST';' TRUE
         #EOF# COMES?
            DROP FALSE
            MARK >R
           DECLARATOR-LIST';'
           R> ADVANCED?   ;

OFF

\ *** LOCK O. 96, EXBLOCK 60

\ PARSER: COMPOUND, PROGRAM    09MAY94PZ

  MAKE COMPOUND ( -- )
     NESTLOCAL
      DECLARATION? NOT 
      STATEMENT? NOT 
     ASCII  #CHAR# EXPECT
     UNNESTLOCAL ;

 VARIABLE MAIN()-ADR

 : COMPILE-PROGRAM ( -- )
     FETCHWORD
      DEFINITION? NOT 
     " MAIN" FINDGLOBAL ?DUP 0=
         MAIN()-ADR OFF EXIT 
     2@ FUNCTION?
         DROP MAIN()-ADR ! EXIT 
     *BAD-MAIN* FATAL ;
